;:::::::: FONCTIONS DE CONSTRUCTION ::::::::

; Poser un cube (sur le sol ou sur un autre cube le cas échéant)
; ATTENTION : les coordonnées passées doivent être impaires
; exemple : (posercube 'cube6 '1 '3)
(defun posercube (cube abs ord)
  (if (accesg 'cubes cube)
      (print '"Erreur: ce cube existe déjà")
      (initg cube ())
      (majg cube 'nom cube)
      (majg cube 'x abs)
      (majg cube 'y ord)
      (majg cube 'z (+ (maxz (listerz abs ord) -1) 2))
      (majptcards cube)
      (if (or (trophaut cube) (troplarge (pont cube)) (not (stable (edifice cube))))
	  ; si pas stable
	  ; rq : on pourrait eventuellement supprimer la varibale globale, mais on ne sait pas faire
	  ; rq2 : elle sera de toute façon écrasé si on recrée un cube du même nom
	  (print "Erreur : impossible de placer le cube ici, l'édifice s'écroulerait")
	  ; si stable
	  (majg 'cubes cube 't)
	  (majvoisins cube)
	  t)))

; Coller un cube à un autre
; exemple : (collercube 'cube7 'est 'cube5)
(defun collercube (cube face cubecible)
  (if (accesg 'cubes cube)
      (print '"Erreur: ce cube existe déjà")
      (if (not (accesg 'cubes cubecible))
	  (print '"Erreur: le cube cible n'existe pas")
	  (if (not (eq (accesg cubecible face) 'vide))
	      (print '"Erreur: il y a déjà un cube ici")
	      (initg cube ())
	      (majg cube 'nom cube)
	      ; Création des coordonnées du nouveau cube selon le cube cible et sa face
	      (cond ((eq face 'ouest)
		     (majg cube 'x (- (accesg cubecible 'x) 2))
		     (majg cube 'y (accesg cubecible 'y))
		     (majg cube 'z (accesg cubecible 'z)))
		    ((eq face 'est)
		     (majg cube 'x (+ (accesg cubecible 'x) 2))
		     (majg cube 'y (accesg cubecible 'y))
		     (majg cube 'z (accesg cubecible 'z)))
		    ((eq face 'sud)
		     (majg cube 'x (accesg cubecible 'x))
		     (majg cube 'y (- (accesg cubecible 'y) 2)) 
		     (majg cube 'z (accesg cubecible 'z)))
		    ((eq face 'nord)
		     (majg cube 'x (accesg cubecible 'x))
		     (majg cube 'y (+ (accesg cubecible 'y) 2)) 
		     (majg cube 'z (accesg cubecible 'z)))
		    ((eq face 'haut)
		     (majg cube 'x (accesg cubecible 'x))
		     (majg cube 'y (accesg cubecible 'y))
		     (majg cube 'z (+ (accesg cubecible 'z) 2)))
		    ((eq face 'bas)
		     (majg cube 'x (accesg cubecible 'x))
		     (majg cube 'y (accesg cubecible 'y))
		     (majg cube 'z (- (accesg cubecible 'z) 2))))
	      (majptcards cube)
	      (if (or (trophaut cube) (troplarge (pont cube)) (not (stable (edifice cube))))
		  ; si pas stable
		  ; rq : on pourrait eventuellement supprimer la varibale globale, mais on ne sait pas faire
		  ; rq2 : elle sera de toute façon écrasé si on recrée un cube du même nom
		  (print "Erreur : impossible de placer le cube ici, l'édifice s'écroulerait")
		  ; si stable
		  (majg 'cubes cube 't)
		  (majvoisins cube)
		  t)))))