;:::::::: FONCTIONS DE MISE EN COULEUR ::::::::

; Colorier un cube avec l'une des 6 couleurs de base
(defun couleur (cube nomcoul)
  (majg cube 'r (nth (indice nomcoul '(rouge jaune vert cyan bleu magenta) 0) '(1 1 0 0 0 1)))
  (majg cube 'v (nth (indice nomcoul '(rouge jaune vert cyan bleu magenta) 0) '(0 1 1 1 0 0)))
  (majg cube 'b (nth (indice nomcoul '(rouge jaune vert cyan bleu magenta) 0) '(0 0 0 1 1 1)))
  t)

; Colorier un cube avec les valeurs RVB (de 0 à 255)
(defun couleurrvb (cube r v b)
  (majg cube 'r (/ (float r) 255))
  (majg cube 'v (/ (float v) 255))
  (majg cube 'b (/ (float b) 255))
  t)

; Colorier un cube avec l'une des 6 couleurs de base prise au hasard
(defun couleuraleat (cube)
  (couleur cube (nth (random 6) '(rouge jaune vert cyan bleu magenta)))
  t)

; Colorier un cube avec des valeurs RVB prises au hasard
(defun couleuraleatrvb (cube)
  (majg cube 'r (/ (float (random 255)) 255))
  (majg cube 'v (/ (float (random 255)) 255))
  (majg cube 'b (/ (float (random 255)) 255))
  t)

; Colorier tous les cubes avec les 6 couleurs de base, prises au hasard
(defun colorier ()
  (mapcar '(lambda (cube) (couleuraleat cube)) (mapcar 'car cubes))
  t)

; Colorier tous les cubes avec des valeurs RVB prises au hasard
(defun colorierrvb ()
  (mapcar '(lambda (cube) (couleuraleatrvb cube)) (mapcar 'car cubes))
  t)
