;:::::::: FONCTIONS D'ECHANGE ::::::::

; Pour un cube, renvoyer la liste des cubes de son édifice posés après lui (dans l'ordre)
(defun hist (cube edifice cubesinv LC)
  (cond ((eq (car cubesinv) cube)     (cons cube LC))
	((app (car cubesinv) edifice) (hist cube edifice (cdr cubesinv) (cons (car cubesinv) LC)))
	(t                            (hist cube edifice (cdr cubesinv) LC))))

; Rajouter les hauteurs des cubes dans l'historique (en a-List)
(defun sauvez (histo)
  (mapcar '(lambda (cube) (list cube (accesg cube 'z))) histo))

; Appeler histo de manière simple (avec sauvegarde des hauteurs)
(defun histo (cube)
  (sauvez (hist cube (edifice cube) (presents cubes nil) nil)))

; Mettre un cube dans la zone de stockage
(defun stocker (cube)
  (majg cube 'z (+ (maxz (listerz (accesg cube 'x) (+ (accesg cube 'y) 20)) -1) 2))
  (majg cube 'y (+ (accesg cube 'y) 10))
  (majg 'cubes cube nil))

; Mettre tous les cubes d'un historique dans la zone de stockage
(defun stockertout (histo)
  (mapcar '(lambda (cube) (stocker cube)) (mapcar 'car (reverse (cdr histo)))))

; Enlever un cube dans la zone de stockage
(defun destocker (cube svg)
  (majg cube 'z svg)
  (majg cube 'y (- (accesg cube 'y) 10))
  (majg 'cubes cube t))

; Enlever tous les cubes d'un historique dans la zone de stockage
(defun destockertout (histo)
  (mapcar '(lambda (cpl) (destocker (car cpl) (cadr cpl))) (cdr histo)))

; Echange de deux cubes
(defun echangercubes (cubea cubeb)
  (echangercubes2 cubea (histo cubea) cubeb))
(defun echangercubes2 (cubea histoa cubeb)
  (enlevercubes histoa cubea)
  (echangercubes3 cubea histoa cubeb (histo cubeb)))
(defun echangercubes3 (cubea histoa cubeb histob)
  (enlevercubes histob cubeb)
  (echangercubes4 cubea histoa cubeb histob (accesg cubea 'x) (accesg cubea 'y)))
(defun echangercubes4 (cubea histoa cubeb histob xa ya)
  (remettrecubes cubea (accesg cubeb 'x) (accesg cubeb 'y) (cadr (car histob)) histob)
  (remettrecubes cubeb xa ya (cadr (car histoa)) histoa)
  (majhisto cubea cubeb)
  (majptcards cubea)
  (majvoisins cubea)
  (majptcards cubeb)
  (majvoisins cubeb))

; Enlever un cube et ceux qui le bloquent
(defun enlevercubes (histo cube)
  (stockertout histo)
  (majg cube 'z (+ (maxz (listerz (accesg cube 'x) (- (accesg cube 'y) 10)) -1) 2))
  (majg cube 'y (- (accesg cube 'y) 10))
  (majg 'cubes cube nil))

; Remettre un cube et ceux qui vont le bloquer
(defun remettrecubes (cube nvx nvy nvz histo)
  (majg cube 'x nvx)
  (majg cube 'y (+ nvy 10))
  (majg cube 'z nvz)
  (majg 'cubes cube t)
  (destockertout histo))

; Mettre à jour l'historique "cubes" après échange des cubes
(defun majhisto (cubea cubeb)
  (initg 'cubes (mapcar '(lambda (cpl)
			   (cond ((eq (car cpl) cubea) (cons cubeb (cdr cpl)))
				 ((eq (car cpl) cubeb) (cons cubea (cdr cpl)))
				 (t                    cpl)))
			cubes)))