;:::::::: CONSTRUCTION DU LABYRINTHE ::::::::

; Construction d'un mur ou condamnation d'une porte
(defun mur (cube face)
  (majg cube (cadr (assoc face '((nord fnord) (sud fsud) (ouest fouest) (est fest) (haut fhaut) (bas fbas)))) 0)
  t)

; Construction d'une ouverture dans une face d'un cube
(defun porte (cube face)
  (majg cube (cadr (assoc face '((nord fnord) (sud fsud) (ouest fouest) (est fest) (haut fhaut) (bas fbas)))) 1)
  t)

; Construction d'une porte à clef dans une face d'un cube
(defun porteclef (cube face)
  (majg cube (cadr (assoc face '((nord fnord) (sud fsud) (ouest fouest) (est fest) (haut fhaut) (bas fbas)))) 2)
  t)

; Construction d'une baie vitrée dans une face cube
(defun baie (cube face)
  (majg cube (cadr (assoc face '((nord fnord) (sud fsud) (ouest fouest) (est fest) (haut fhaut) (bas fbas)))) 3)
  t)

; Construction d'un labyrinthe simple
; (Deux cubes collés sont obligatoirement ouverts sur les faces qui correspondent)
(defun labsimple (edifice)
  (mapcar '(lambda (cube) (majportes cube)) edifice)
  t)

; Mise à jour des portes cube par cube
(defun majportes (cube)
  (mapcar '(lambda (face)
	     (if (not (eq (accesg cube face) 'vide))
		 (porte cube face)
	         (mur cube face)))
	     '(nord sud ouest est haut bas))
  t)