;:::::::: FONCTION POUR L'INTERFACAGE ::::::::

; Exporter les données pour avoir un affichage 3D
(defun interface ()

  ; On crée un buffer temporaire
  (create-file-buffer "temp")

  ; Que l'on rends actif
  (set-buffer (get-buffer "temp"))

  ; On y place les infos nécessaires
  (print (list 'nbcubes= (length cubes)) (get-buffer "temp"))
  (mapcar '(lambda
	     (cube)
	     (print (list
		     'x= (accesg cube 'x)
		     'y= (accesg cube 'y)
		     'z= (accesg cube 'z)
		     'r= (accesg cube 'r)
		     'v= (accesg cube 'v)
		     'b= (accesg cube 'b))
		    (get-buffer "temp")))
	  (mapcar 'car cubes))
 

  ; On enregistre dans un fichier texte
  (write-file "prj.interface.txt" nil)

  ; Et on supprime le buffer temporaire
  (kill-buffer (get-buffer "temp"))
)

; Interfacer une fonction (pour avoir l'affichage 3D en direct)
(defun interfacer (f)
  (fset f
	(ajfin '(interface)
	       (symbol-function f)))
  t)