;:::::::: FONCTIONS DE TRACAGE ::::::::

; Affiche la liste des arguments et la fonction
(defun printarg (lparam f)
  (print (append lparam (list '-> f)))
  lparam)

; Affiche la fonction et sa valeur de sortie
(defun printval (f sortie)
  (print (list f '-> sortie))
  sortie)

; Ajoute r  la position n dans la liste L
(defun ajnieme (n r L)
  (if (zerop n)
      (cons r L)
      (cons (car L) (ajnieme (1- n) r (cdr L)))))

; Ajoute r au dernier terme de L et met le tout en liste
(defun ajdernier (r L)
  (if (null (cdr L))
      (list (append r L))
      (cons (car L) (ajdernier r (cdr L)))))

; Formate une liste de parmamtre
(defun dev (L)
  (apply 'append (mapcar (lambda (x) (list (list 'quote x) (list 'quote '=) x)) L)))

; Trace la fonction f de parametres param ( formater) si elle n'a pas dj t trae
(defun trace (f)
  (if (not (eq (car (nth '2 (symbol-function f))) 'printarg))
      (fset f
	    (ajnieme 2 (list 'printarg
			     (cons 'list (dev (cadr (symbol-function f))))
			     (list 'quote f))
		     (ajdernier (list 'printval (list 'quote f))
				(symbol-function f)))))
  f)
